/*
 * cmd_print.c - Commands to print the data
 * $Fuller: myprograms/fread/cmd_print.c,v 1.3 2003/06/05 17:25:15 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>

#include <fread.h>


/* Pull in globals */
extern FR_FILE **allfiles;
extern int curfile;


/* Print contents of the buffer */
void
cmd_print(const char *dummy)
{
	
	/* Well, for one thing... */
	if(allfiles[curfile]->buflen==0)
	{
		printf("No data read from current file.\n");
		return;
	}

	/* Otherwise, it's easy */
	printf("Current buffer between arrows (%li bytes):\n===>%s<===\n",
			(long)allfiles[curfile]->buflen, allfiles[curfile]->readbuf);
	
	return;
}


/* Pipe the contents of the buffer to less/more */
void
cmd_less(const char *dummy)
{
	char *envpag;
	FILE *pagerproc=NULL;

	/* Well, for one thing... */
	if(allfiles[curfile]->buflen==0)
	{
		printf("No data read from current file.\n");
		return;
	}

	/* Best case scenario */
	if((envpag = getenv("PAGER"))!=NULL)
		pagerproc=popen(envpag, "w");
	
	/* If that failed, we guess 'less', then 'more', then bail */
	if(pagerproc==NULL)
		pagerproc=popen("less", "w");

	if(pagerproc==NULL)
		pagerproc=popen("more", "w");
	
	if(pagerproc==NULL)
	{
		printf("Error: Can't locate a pager.  Try setting $PAGER.\n");
		return;
	}

	/* We're golden */
	fprintf(pagerproc, "%s", allfiles[curfile]->readbuf);
	pclose(pagerproc);

	return;
}
