/*
 * fread.h - fread header file
 * $Fuller: myprograms/fread/fread.h,v 1.3 2003/06/05 19:25:23 fullermd Exp $
 */


#include <sys/types.h>

/* Macros */
#define FREAD_VERSION	"1.0"
#define UMIN(x,y)       ( ((x)<(y)) ? (x) : (y) )


/* Typedef */
typedef struct fr_file FR_FILE;


/* Prototypes */
/* Internal utility functions */
void cmd_proc(const char *);
int fr_close(FR_FILE *);
int fr_open(FR_FILE *);
char *fr_getline(void);
void fr_setcurfile(int);

/* Memory management functions */
FR_FILE *fr_alloc_frfile(void);
void fr_free_frfile(FR_FILE *);

/* Commands */
#define CMD_FUN(x)      void (x)(const char *);
CMD_FUN(cmd_close)
CMD_FUN(cmd_file)
CMD_FUN(cmd_help)
CMD_FUN(cmd_less)
CMD_FUN(cmd_list)
CMD_FUN(cmd_open)
CMD_FUN(cmd_print)
CMD_FUN(cmd_read)
CMD_FUN(cmd_seek)
CMD_FUN(cmd_quit)
CMD_FUN(cmd_version)


/* Structures */
struct fr_file
{
	char			*name;
	int				desc;
	off_t			curoffset;
	char			*readbuf;
	size_t			buflen;
	size_t			bufsize;
};
