/*
 * util.c - Simple utility functions
 * $Fuller: myprograms/fread/util.c,v 1.1.1.1 2003/06/05 16:54:49 fullermd Exp $
 */

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <fread.h>

extern char *prompt;
extern FR_FILE **allfiles;
extern int curfile;

/* Set our current file */
void
fr_setcurfile(int newcur)
{
	size_t alsz;

	/* Special-case for no files */
	if(newcur==-1)
	{
		curfile = -1;
		free(prompt);
		prompt = strdup("> ");
		if(prompt==NULL)
		{
			perror("malloc()");
			return;
		}
		return;
	}

	/* Else, set the requested file */
	curfile = newcur;
	free(prompt);
	/* [ + filenum + ] + ' ' + filename + " > " + '\0' */
	/* We're allowing up to 9,999,999 files open */
	alsz = 1 + 7 + 1 + 1 + strlen(allfiles[newcur]->name) + 3 + 1;
	prompt = malloc(alsz);
	if(prompt==NULL)
	{
		perror("malloc()");
		return;
	}
	sprintf(prompt, "[%d] %s > ", (newcur+1), allfiles[newcur]->name);

	return;
}
